﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Net.Http;
using System.Web.Http;
using ServerOperations.Models;
using System.Collections;
using System.Web.Http.OData;
using System.Web.Http.OData.Query;

namespace ServerOperations.Controllers
{
    public class OrdersController : ApiController
    {
        NorthwindDataContext db = new NorthwindDataContext();
        
        // GET api/<controller>       
        public PageResult<OrdersView> Get(ODataQueryOptions opts)
        {
            var results = db.OrdersViews.AsQueryable();
            var count = results.Count();
            if (opts.OrderBy != null)
                results = opts.OrderBy.ApplyTo(results);
            if (opts.Filter != null)
            {
                if (opts.Filter.RawValue.Contains("substring"))
                {
                    string key = opts.Filter.RawValue.Split(new string[] { "'" }, StringSplitOptions.None)[1];
                    results = results.Where(fil => fil.CustomerID.Contains(key) || fil.EmployeeID.ToString().Contains(key) || fil.Freight.ToString().Contains(key) || fil.OrderID.ToString().Contains(key));
                }
                else
                    results = opts.Filter.ApplyTo(results, new ODataQuerySettings()).Cast<OrdersView>();
            }
            if (opts.InlineCount != null)
                count = results.Count();
            var data = results;
            //var count = emp.Count;
            //if (opts.Filter != null)
            //    count = data.Cast<OrdersView>().ToList().Count;

            return new PageResult<OrdersView>(results, null, count);
        }

        // GET api/<controller>/
        public string Get(int id)
        {
            return "value";
        }

        // POST api/<controller>
        public void Post(EmployeePhoto employee)
        {
            NorthwindDataContext db = new NorthwindDataContext();

            db.EmployeePhotos.InsertOnSubmit(new EmployeePhoto()
            {
                EmployeeID = employee.EmployeeID,
                Name = employee.Name               
            });
            db.SubmitChanges();

        }

        // PUT api/<controller>/5
        public void Put(EmployeePhoto employee)
        {
            EmployeePhoto emp = (EmployeePhoto)db.EmployeePhotos.Single(s => s.EmployeeID == employee.EmployeeID);

            emp.EmployeeID = employee.EmployeeID;
            emp.Name = employee.Name;
            

            db.SubmitChanges();

        }

        // DELETE api/<controller>/5
        public void Delete(int id)
        {
            EmployeePhoto emp = (EmployeePhoto)db.EmployeePhotos.Single(s => s.EmployeeID == id);

            db.EmployeePhotos.DeleteOnSubmit(emp);

            db.SubmitChanges();
        }

    }
}